<?php

/*
* 2007-2013 PrestaShop  
*
* NOTICE OF LICENSE
*
* This source file is subject to the Academic Free License (AFL 3.0)
* that is bundled with this package in the file LICENSE.txt.
* It is also available through the world-wide-web at this URL:
* http://opensource.org/licenses/afl-3.0.php
* If you did not receive a copy of the license and are unable to
* obtain it through the world-wide-web, please send an email
* to license@prestashop.com so we can send you a copy immediately.
*
*         DISCLAIMER   *
* *************************************** */
/* Do not edit or add to this file if you wish to upgrade Prestashop to newer
* versions in the future.
* ****************************************************
* @category   Belvg
* @package    Belvg_FAQ
* @author    Alexander Simonchik <support@belvg.com>
* @site
* @copyright  Copyright (c) 2010 - 2013 BelVG LLC. (http://www.belvg.com)
* @license    http://store.belvg.com/BelVG-LICENSE-COMMUNITY.txt 
*/

require_once (dirname(__file__) . '/shopcontrol.php');
require_once (dirname(__file__) . '/classes/SC.php');

class FiscalCheck extends ModuleAdminController
{
	protected $_module = NULL;

	protected $position_identifier = 'id_sctrl_fisc';
	
	
	public function __construct()
    {
        $this->context = Context::getContext();
        $this->table = 'sctrl_fisc';
        //$this->identifier = 'id_belvg_faq';
		$this->colorOnBackground = false;
        $this->className = 'SC';
        $this->_defaultOrderBy = 'position';		
        $this->_defaultOrderWay = 'DESC';
		
		//$this->orderWay ='desc';
        $this->lang = TRUE;
		$this->_select = 'a.`id_sctrl_fisc` as `id_temp`';
		
        
       $this->addRowAction('delete');	    

        $this->bulk_actions = array(
		'delete' => array('text' => $this->l('Delete selected'),'confirm' => $this->l('Delete selected items?')), 
		'id_temp' => array('text' => $this->l('Delete selected'),'confirm' => $this->l('Delete selected items?')), 			
					);

       // Shop::addTableAssociation($this->table, array('type' => 'shop'));
        
		$this->fields_list = array(
			/* 'id_sctrl_fisc' => array('title' => $this->l('ID'), 'align' => 'center', 'width' => 25),*/
			'position' => array('title' => $this->l('#'), 'width' => 40,'filter_key' => 'position', 'align' => 'center', 'position' => 'position'),
			'date_add' => array('title' => $this->l('Дата'), 'width' => '100', 'filter_key' => 'date_add'),
			'zakaz' => array('title' => $this->l('Заказ'), 'width' => '200', 'filter_key' => 'zakaz'),
			'summa' => array('title' => $this->l('Сумма'), 'width' => '50', 'filter_key' => 'summa'),
			'exterNum' => array('title' => $this->l('№ заказа'), 'width' => '50', 'filter_key' => 'exterNum'),
			'email' => array('title' => $this->l('E-mail'), 'width' => '50', 'filter_key' => 'email'),			
			'status' => array('title' => $this->l('Shop control Касса!'), 'width' => '50', 'filter_key' => 'status',
		
			
			'icon' => array(                    // If set, an icon will be displayed with icon key matching the field value.
      0 => 'disabled.gif',                         // Used in combination with type == bool (optional).
      1 => 'enabled.gif',
      'default' => 'disabled.gif'
    )
	),
			/*'active' => array('title' => $this->l('Displayed'), 'width' => 25, 'align' => 'center', 'active' => 'status', 'type' => 'bool', 'orderby' => FALSE),*/
			
			
			'info' => array('title' => $this->l('Инфо'), 'width' => '100', 'filter_key' => 'info'),
			'id_temp' => array(
        'title' => $this->l('Действие'),
        'align' =>'text-right',
        'search' => false,
        'callback' => 'viewMyButton'
   ),
			
		/*	'title' => array('title' => $this->l('Title'), 'width' => '300', 'filter_key' => 'b!title'),*/
			
			/*'active' => array('title' => $this->l('Displayed'), 'width' => 25, 'align' => 'center', 'active' => 'status', 'type' => 'bool', 'orderby' => FALSE)*/
		);

        parent::__construct();
    }
		


		
	
    
	

	public function initProcess()
{
    parent::initProcess();
    if ($id = Tools::getValue('expi'.$this->table))
    {
	$upd = Configuration::get('upd');	
		if ($upd !=0) {
			
			
			
			
		
		$sctrl_fisc = _DB_PREFIX_."sctrl_fisc";	
		
		$sql = 'SELECT * FROM `'.$sctrl_fisc.'`
	WHERE id_sctrl_fisc ='.$id;
		if ($row = Db::getInstance()->getRow($sql)) {
		
	//echo $row['id_shop'].' - '.$row['zakaz'];	
			
		$json =$row['zakaz_json']; 
		$id_order =$row['exterNum'];  
		$api_url = Configuration::get('api_url');
		$url =$api_url; 
		$insert = $row['status']; //Если статус 0, то обновляем иначе Новая запись
			
			$curl = curl_init();//иницилизация сеанса
			curl_setopt($curl,CURLOPT_URL, $url); //В этой опции задаётся адрес
			curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST"); //метод POST
			curl_setopt($curl,CURLOPT_SSL_VERIFYPEER, false);//чтобы наш сервер не проверял ваш сертификат (мы с собой никаких сертификатов не принесли, пустите нас так пожалуйста.)
			curl_setopt($curl,CURLOPT_SSL_VERIFYHOST, false);
			curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json',
														 'Content-Length: ' . strlen($json)));
			curl_setopt($curl, CURLOPT_POSTFIELDS, $json);
			curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);//вывода ответа от сервера: в браузер (значение false) или же возвращать ответ (значение true)

			$response = curl_exec($curl);//Получаем данные
			curl_close($curl); 

			/*---------обработка ошибок----------*/

			$resp =json_decode($response); // Превращаем строку в объект

			// Отлавливаем ошибки возникшие при превращении
			switch (json_last_error()) {
			  case JSON_ERROR_NONE:
				$data_error = '';
				break;
			  case JSON_ERROR_DEPTH:
				$data_error = 'Достигнута максимальная глубина стека';
				break;
			  case JSON_ERROR_STATE_MISMATCH:
				$data_error = 'Неверный или не корректный JSON';
				break;
			  case JSON_ERROR_CTRL_CHAR:
				$data_error = 'Ошибка управляющего символа, возможно верная кодировка';
				break;
			  case JSON_ERROR_SYNTAX:
				$data_error = 'Синтаксическая ошибка';
				break;
			  case JSON_ERROR_UTF8:
				$data_error = 'Некорректные символы UTF-8, возможно неверная кодировка';
				break;  
			  default:
				$data_error = 'Неизвестная ошибка';
				break;
			}	
			
			// Если ошибки есть, то выводим их или как то обрабатываем
		if($data_error !='') {
		$err = 'err: '.$data_error.'&#8195;';
		}
		else {
		$err ='';	
		}
			// Присваиваим данные переменным

			$result = $resp->result; 
			$code = $resp->code;
			$info = $resp->info;
			$exterNum = $resp->data->exterNum;
			$id_res = $resp->data->id;

			if ($result=='ok') {
			$status=1;
			$status_info='';
			} else {
				$status=0;
				$status_info = $code.' '.$info;
				}

//$insert=1;
			$PositionSC = new SC;			
			if ($insert==1) {
			$sctrl_fisc = _DB_PREFIX_."sctrl_fisc";				
			Db::getInstance()->autoExecute($sctrl_fisc, array(

				'position' => $PositionSC -> getLastPosition(),
				'date_add' => date("Y-m-d H:i:s"),
				'zakaz' => $row['zakaz'],	
				'zakaz_json' => $json,	
				'summa' => $row['summa'],
				'exterNum' => $row['exterNum'],
				'email' => $row['email'],
				'status' =>    $status,
				'info' =>    $status_info,
				'active' =>    1
					
			), 'INSERT');
			}
			else { 			
			
			 
			$query = "UPDATE `"._DB_PREFIX_."sctrl_fisc` 
			 SET `status` =". $status . ",
			 `update_date` = NOW()
			 
			 WHERE `id_sctrl_fisc`= " . $id . ";";			 
			
			Db::getInstance()->Execute($query);   
				
				
			}
		
						/*---------------Логирование--------*/
		
						$log_en = Configuration::get('logi_enabled_1');	
	
						if ($log_en =='on') { //Если надо пишем лог
						
						$info ='Повтор '.$info;
						
						$log = date("Y-m-d H:i:s").'&#8195;'.$err.'&#8195;result: '.$result.'&#8195;';
						$log .="code: ".$code.'&#8195;';
						$log .="info: ".$info.'&#8195;';
						$log .="id: ".($id_res*1).'&#8195;';
						$log .="exterNum: ".$id_order.' ';
						$log .="\r\n";

						$log_file_name = Configuration::get('log_file_name');

						$fa =dirname(__DIR__).'/shopcontrol/'.$log_file_name.'.txt';

						$text_1=''; $n=0;

						 if ($log!="") 
						{
						/*--------ограничим лог 500 строками-----*/
						$handle = @fopen($fa, "r");
						if ($handle) {
							while (($buffer = fgets($handle, 4096)) !== false) {
							$text_1 .=$buffer; 	
							if ($n==500) break;
							$n++;
							}	
						fclose($handle);
						}

						//$text_1=file_get_contents($fa); 

						$fd=$log.$text_1; 
						$f_out = fopen($fa,"w"); 
						fwrite($f_out, $fd);  
						fclose($f_out); 
						} 

						}
		
		
		
			
			

		}


	}
	Configuration::updateValue('upd', 0);
	
	
	
	$admin = explode(DIRECTORY_SEPARATOR,_PS_ADMIN_DIR_);
	$admin_folder = array_pop((array_slice($admin, -1)));
	$admin_url =_PS_BASE_URL_.__PS_BASE_URI__.$admin_folder;
	
	//http://ps17.shop-ctrl.ru/module/ps_checkpayment/validation
	
	echo "
	<script>
	setTimeout(function(){window.location='{$admin_url}/?controller=FiscalCheck'}, 1);
	</script>
	";
	//Tools::updateValue(('expi'.$this->table), '');	
    }
	
}
	
	
public function viewMyButton($id)
{


$sql = '
        SELECT `status`
        FROM `'._DB_PREFIX_.'sctrl_fisc`
		WHERE `id_sctrl_fisc` = '.(int)$id.'
		;
		';
		
  $status	= Db::getInstance()->getValue($sql);

if ($status==1) {return;}
	
Configuration::updateValue('upd', 1);
$tpl = $this->createTemplate('helpers/list/list_action_edit.tpl');
		if (!array_key_exists('Test', self::$cache_lang))
			self::$cache_lang['Test'] = $this->l('Повторить', 'Helper');
	
		$tpl->assign(array(
				'href' => self::$currentIndex.'&token='.$this->token.'&id='.$id.'&expi'.$this->table.'='.$id,
				'action' => self::$cache_lang['Test'],
				'id' => $id
		));
	
		return $tpl->fetch();
}
	


	
		
		
		//$StatusSC = new AdminStatusesControllerCore;



//	'position' => $StatusSC -> getLastPosition()
	
	
	
	


    

	/*----------Удалим Тулбар------*/
	public function initToolbar() {
    parent::initToolbar();

   unset( $this->toolbar_btn['new'] );
}
	
	
	
    public function l($string)
    {
        if (is_null($this->_module)) {
            $this->_module = new shopcontrol();
        }

        return $this->_module->l($string, __class__);
    }

    public function renderForm()
    {
		/*
        $this->display = 'edit';
        $this->initToolbar();

        $this->fields_form = array(
            'tinymce' => TRUE,
            'legend' => array('title' => $this->l('Field'), 'image' =>
                    '../img/admin/tab-categories.gif'),
            'input' => array(
				array(
					'type' => 'text',
					'label' => $this->l('Title:'),
					'name' => 'title',
					'id' => 'title', 
					'lang' => TRUE,
					'required' => TRUE,
					'hint' => $this->l('Invalid characters:').' <>;=#{}',
					'size' => 50),
				array(
					'type' => 'textarea',
					'label' => $this->l('Block content'),
					'name' => 'content',
					'autoload_rte' => TRUE,
					'lang' => TRUE,
					'required' => TRUE,
					'rows' => 5,
					'cols' => 40,
					'hint' => $this->l('Invalid characters:').' <>;=#{}'),
                array(
                    'type' => 'radio',
                    'label' => $this->l('Displayed:'),
                    'name' => 'active',
                    'required' => FALSE,
                    'class' => 't',
                    'is_bool' => FALSE,
                    'values' => array(array(
                            'id' => 'require_on',
                            'value' => 1,
                            'label' => $this->l('Yes')), array(
                            'id' => 'require_off',
                            'value' => 0,
                            'label' => $this->l('No')))),
                ),
            'submit' => array('title' => $this->l('   Save   '), 'class' => 'button'));

        if (Shop::isFeatureActive()) {
            $this->fields_form['input'][] = array(
                'type' => 'shop',
                'label' => $this->l('Shop association:'),
                'name' => 'checkBoxShopAsso',
                );
        }
*/
        return parent::renderForm();
    }
    
    /**
     * AdminFastCheckoutFields::initHeader()
     * 
     * @return void
     */
    /* public function initHeader() {
        parent::initHeader();

        // Multishop
        $this->context->smarty->assign(array(
            'is_multishop' => FALSE,
        ));
    } */

}
