<?php

/**
* "Shop control Касса!" module main file.
*
* @author SC <admin@shop-ctrl.ru>
* @link http://internet.shop-ctrl.ru/
* @copyright Copyright &copy; 2017 shop-ctrl.ru
* @license    http://www.opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
* @version 1
*/

if (!defined('_PS_VERSION_'))
	exit;
//проверяет наличия константы PrestaShop (ее номер версии)цель не допустить загрузки этого файла напрямую.

require_once (dirname(__file__) . '/classes/SC.php');

class ShopControl extends Module
{
	private $_html = '';
	private $_postErrors = array();
	
	/*
	 public $tab_array = array(
        array(
            'class_name' => 'FiscalCheck',
            'name' => 'Журнал 54-ФЗ',
        ),
       
    );
*/


	function __construct()
	{
		$this->name = 'shopcontrol';
		$this->tab = 'payments_gateways';
		$this->version = '2.2';
		$this->author = 'internet.shop-ctrl.ru';
		$this->need_instance = 0;
		//Ключик из addons.prestashop.com
		// $this->is_configurable = 0;
		$this->module_key='';

		parent::__construct();

		$this->displayName = $this->l('Shop control Kacca! 54-ФЗ');
		$this->description = $this->l('Shop control Kacca! в соответствии с 54-ФЗ');
		
		$this->confirmUninstall = $this->l('Вы уверены, что хотите удалить?');
		
		$this->tabs = array(
        array(
            'class_name' => 'FiscalCheck',
            'ParentClassName' => 'AdminCatalog',
            'name' => array(
                'en-US' => '54-fz',
                'ru-RU' => 'Журнал 54-ФЗ'
            ),
            'visible' => true,
            'icon' => 'store'
        )
		);
		
		if (!Configuration::get('MYMODULE_NAME'))
      $this->warning = $this->l('Не указано имя');
		
	}

	public function createTab($class_name, $parent = null, $name)
	{
		if (!is_array($name))
			$name = array('en' => $name);
		elseif (is_array($name) && !count($name))
			$name = array('en' => $class_name);
		elseif (is_array($name) && count($name) && !isset($name['en']))
			$name['en'] = current($name);

		$tab = new Tab();
		$tab->class_name = $class_name;
		$tab->module = $this->name;
		$tab->id_parent = (!is_null($parent) ? Tab::getIdFromClassName($parent) : 0);
		if (is_null($parent) && version_compare(_PS_VERSION_, '1.6.0.0', '<'))
			$this->copyTabIconInRoot($class_name);
		$tab->active = 1;
		foreach (Language::getLanguages() as $l)
			$tab->name[$l['id_lang']] = (isset($name[$l['iso_code']]) ? $name[$l['iso_code']] : $name['en']);
        return $tab->save();
	}
	
	public function copyTabIconInRoot($icon)
	{
		$icon = $icon.'.gif';
		$path = _PS_MODULE_DIR_.basename(dirname(__FILE__)).'/';
		if (!file_exists($path.$icon) && file_exists($path.'views/img/'.$icon) && _PS_VERSION_ < 1.6)
			copy($path.'views/img/'.$icon, $path.$icon);
	}
	
		public static function deleteTab($class_name)
	{
		$tab = Tab::getInstanceFromClassName($class_name);
		return $tab->delete();
	}
	
	
	public function install()
	{
		
		$rand = rand(1111, 999999999);		
		$rand_hex = dechex($rand);
		$log_file_name= md5($rand_hex);			
		
		 if (Shop::isFeatureActive())
		Shop::setContext(Shop::CONTEXT_ALL);

		if (!parent::install() ||
		!$this->registerHook('header') ||
		!$this->registerHook('actionPaymentConfirmation') ||
		!$this->registerHook('actionOrderStatusUpdate') ||
		!$this->registerHook('actionObjectOrderAddAfter') ||		
		!Configuration::updateValue('api_url', 'https://kassa.shop-ctrl.ru/api/1/api.php') ||
		!Configuration::updateValue('api_token', '') ||
		!Configuration::updateValue('send_check', 0) ||		
		!Configuration::updateValue('api_app', '') ||	
		!Configuration::updateValue('nds_id', 1) ||	
		!Configuration::updateValue('api_comment', 'интернет заказ') ||	
		!Configuration::updateValue('log_file_name', $log_file_name) ||	
		!Configuration::updateValue('logi_enabled_1', '') ||	
		!$this->createTab('FiscalCheck', 'AdminCatalog', array('ru' => 'Журнал 54-ФЗ','en' => '54-fz')) ||	
		!Configuration::updateValue('upd', 0)			
		)
		return false;
		
		
  	
		
		$sql = array();
        include (dirname(__file__) . '/init/install_sql.php');
        foreach ($sql as $s) {
            if (!Db::getInstance()->Execute($s)) {
                return FALSE;
            }
        }
		
	/*
		foreach ($this->tab_array as $tab) {
            $new_tab = new Tab();
            $new_tab->class_name = $tab['class_name'];
            //$new_tab->id_parent = Tab::getCurrentParentId();
            $new_tab->id_parent = (int) Tab::getIdFromClassName('AdminOrders');
            $new_tab->module = $this->name;
			
            $languages = Language::getLanguages();
            foreach ($languages as $language) {
                $new_tab->name[$language['id_lang']] = $tab['name'];
            }

            $new_tab->add();
        }
		*/
		
		
			
		
		
		if (!Hook::getIdByName('scapiInit')) {
			$hook = new Hook();
			$hook->name = 'scapiInit';
			$hook->title = $this->displayName;
			$hook->description = $this->description;
			$hook->add();
		}
		
	
			/*--------Все статусы------*/
			$sql = 'SELECT * FROM `'._DB_PREFIX_.'order_state_lang`';
			if ($results = Db::getInstance()->ExecuteS($sql))
			foreach ($results as $row)
			{
			$st_var = 'stat_enabled_'.$row['id_order_state'];
			Configuration::updateValue($st_var, 0);		
			}
			
	
	return true;
	
	}

	public function uninstall()
	{
		
		if (!parent::uninstall() ||		
		!Configuration::deleteByName('api_url') ||
		!Configuration::deleteByName('api_token') ||
		!Configuration::deleteByName('api_app') ||
		!Configuration::deleteByName('send_check') ||
		!Configuration::deleteByName('nds_id') ||
		!Configuration::deleteByName('api_comment') ||
		!Configuration::deleteByName('log_file_name') ||
		!Configuration::deleteByName('logi_enabled_1') ||
		!Configuration::deleteByName('upd')	|| 
		$this->deleteTab('FiscalCheck')
		)
		return false;
		
		
		
		if ($id_hook = Hook::getIdByName('scapiInit')) {
			$hook = new Hook($id_hook);
			$hook->delete();
		}
		
		/*
	    if (!parent::uninstall()) {
            return FALSE;
        }
	    */
		
		
		
	    $sql = array();
        include (dirname(__file__) . '/init/uninstall_sql.php');
        foreach ($sql as $s) {
            if (!Db::getInstance()->Execute($s)) {
                return FALSE;
            }
        }
	    
		/*-----В версии 1,6
	    $idTabs = array();
        $idTabs[] = Tab::getIdFromClassName('FiscalCheck');       
        foreach ($idTabs as $idTab) {
            if ($idTab) {
                $tab = new Tab($idTab);
                $tab->delete();
            }
        }
	    ----------------------------*/
		
	    
	    /*---------Удалим-------------*/
			$sql = 'SELECT * FROM `'._DB_PREFIX_.'order_state_lang`';
			if ($results = Db::getInstance()->ExecuteS($sql))
			foreach ($results as $row)
			{
			$st_var = 'stat_enabled_'.$row['id_order_state'];
			Configuration::deleteByName($st_var);				
			}
		/*-------Удаляем лог если есть-------*/

		$log_file_name = Configuration::get('log_file_name');
		$file_name =dirname(__DIR__).'/shopcontrol/'.$log_file_name.'.txt';	
		if (is_readable($file_name)){  
		$result = unlink($file_name);  
		}
		
		
		return true;
		
	}

	
	
	
	
	public function getContent()
	{
		if (Tools::isSubmit('submitscapi'))
		{
			$this->_postValidation();
			if (!sizeof($this->_postErrors))
				$this->_postProcess();
			else
				foreach ($this->_postErrors AS $err)
					$this->_html .= $this->displayError($err);;
		}
		$this->_displayForm();
		return $this->_html;
	}

	private function initToolbar()
	{
		$this->toolbar_btn['save'] = array(
			'href' => '#',
			'desc' => $this->l('Сохранено')
		);
		return $this->toolbar_btn;
	}

	protected function _displayForm()
	{
		$this->_html .='<h2>"Shop control <span style="color:#CC2226;">Kacca!</span>" в соответствии с 54-ФЗ</h2>';
		
		
		$options = array(
			array(
			'id_option' => 1,                 
			'name' => 'без НДС'             
			),
			array(
			'id_option' => 2,                 
			'name' => 'НДС 0%'             
			),
			array(
			'id_option' => 10,                
			'name' => 'НДС 10%'              
			),
			array(
			'id_option' => 18,             
			'name' => 'НДС 18%'             
			),
			array(
			'id_option' => 110,                
			'name' => 'НДС 10/110'             
			),
			array(
			'id_option' => 118,                 
			'name' => 'НДС 18/118'              
			)		
		);
		
		//$sctrl_fisc = _DB_PREFIX_."sctrl_fisc";
		
	
	$op	= array(
			array(
			'id_option' => 1,                 // The value of the 'value' attribute of the <option> tag.
			'name' => 'Вести лог'              // The value of the text content of the  <option> tag.
			)
	);
	
	/*-------Добавочка--------*/
	$op_status=array();	
	
	$sql = 'SELECT * FROM `'._DB_PREFIX_.'order_state_lang`';
	if ($results = Db::getInstance()->ExecuteS($sql))
	foreach ($results as $row)
	{
		$name_id = $row['name'].' (id='.$row['id_order_state'].')';
	$add_arr = array('id_option' => $row['id_order_state'],'name' => $name_id);	
	array_push($op_status, $add_arr);	
	}
		
		
	
	
		
		
		
		
		$this->_html .='
		<fieldset>
			<a href="http://internet.shop-ctrl.ru/" target="_blank" style="float:left;margin-right:15px;"><img src="http://help-kassa.shop-ctrl.ru/assets/images/logo.png" alt="ShopControl"></a>
			<h3><b>Этот модуль позволяет Вам фискализировать позиции (отправлять электронный чек покупателю в соответствие с 54-ФЗ) из Вашего интернет-магазина
			с отправкой данных в ОФД и ФНС через Вашу онлайн-кассу.</b></h3><br><br>
			<a target="_blank" style="text-decoration:underline;" href="https://internet.shop-ctrl.ru/kassy.html">Список поддерживаемых онлайн-касс</a><br>
			<a target="_blank" style="text-decoration:underline;" href="https://internet.shop-ctrl.ru">Ссылка на сайт</a><br>
			
			
			<b><a target="_blank" style="text-decoration:underline;" href="http://help-kassa.shop-ctrl.ru/index.php?post_id=271">Инструкция по настройке модуля</a></b>
			<br>
		</fieldset>';
		
		
		
		$this->_display = 'index';
		
		
		$this->fields_form[0]['form'] = array(
				'legend' => array(
				'title' => $this->l('Настройки'),
				'image' => _PS_ADMIN_IMG_.'information.png'				
			),
			
				
			'input' => array(
		
				
				array(
  'type'      => 'radio',                               // This is an <input type="checkbox"> tag.
  'label'     => $this->l('Отправка данных'),        // The <label> for this <input> tag.
  'desc'      => $this->l('Отправлять в Shop.control.Кассу данные для чеков (54-ФЗ)'),   // A help text, displayed right next to the <input> tag.
  'name'      => 'send_check',                              // The content of the 'id' attribute of the <input> tag.
  'required'  => true,                                  // If set to true, this option must be set.
  'class'     => 't',                                   // The content of the 'class' attribute of the <label> tag for the <input> tag.
  'is_bool'   => true,                                  // If set to true, this means you want to display a yes/no or true/false option.
                                                        // The CSS styling will therefore use green mark for the option value '1', and a red mark for value '2'.
                                                        // If set to false, this means there can be more than two radio buttons,
                                                        // and the option label text will be displayed instead of marks.
  'values'    => array(                                 // $values contains the data itself.
    array(
      'id'    => 'active_on',                           // The content of the 'id' attribute of the <input> tag, and of the 'for' attribute for the <label> tag.
      'value' => 1,                                     // The content of the 'value' attribute of the <input> tag.   
      'label' => $this->l('Enabled')                    // The <label> for this radio button.
    ),
    array(
      'id'    => 'active_off',
      'value' => 0,
      'label' => $this->l('Disabled')
    )
  ),
),
				
				array(
					'type' => 'text',
					'label' => $this->l('url'),
					'suffix' => $this->l('Адрес API'),
					'name' => 'api_url',
					'size' => 60,					
				),
				array(
					'type' => 'text',
					'label' => $this->l('token'),
					'suffix' => $this->l('Токен'),
					'name' => 'api_token',
					'size' => 60,					
				),
				array(
					'type' => 'text',
					'label' => $this->l('app'),
					'suffix' => $this->l('Номер кассы'),
					'name' => 'api_app',
					'size' => 60,					
				),
				
				array(
  'type' => 'select',                              // This is a <select> tag.
  'label' => $this->l('nds'),         // The <label> for this <select> tag.
  'desc' => $this->l('Ставка НДС в вашем магазине'),  // A help text, displayed right next to the <select> tag.
  'name' => 'nds_id',                     // The content of the 'id' attribute of the <select> tag.
  'required' => true,                              // If set to true, this option must be set.
  'options' => array(
    'query' => $options,                           // $options contains the data itself.
    'id' => 'id_option',                           // The value of the 'id' key must be the same as the key for 'value' attribute of the <option> tag in each $options sub-array.
    'name' => 'name'                               // The value of the 'name' key must be the same as the key for the text content of the <option> tag in each $options sub-array.
  )
),
	array(
					'type' => 'text',
					'label' => $this->l('comment'),
					'suffix' => $this->l('Комментарий'),
					'name' => 'api_comment',
					'size' => 60,					
				),	

	array(
  'type'    => 'checkbox',                         // This is an <input type="checkbox"> tag.
  'label'   => $this->l('Options'),                // The <label> for this <input> tag.
  'desc'    => $this->l(''),        // A help text, displayed right next to the <input> tag.
  'name'    => 'logi_enabled',                          // The content of the 'id' attribute of the <input> tag.
  'values'  => array(
    'query' => $op,                           // $options contains the data itself.
    'id'    => 'id_option',                        // The value of the 'id' key must be the same as the key for 'value' attribute of the <option> tag in each $options sub-array.
    'name'  => 'name'                              // The value of the 'name' key must be the same as the key for the text content of the <option> tag in each $options sub-array.
  ),
),
	array(
  'type'    => 'checkbox',                         // This is an <input type="checkbox"> tag.
  'label'   => $this->l('На какие статусы срабатывает Модуль'),                // The <label> for this <input> tag.
  'desc'    => $this->l(''),        // A help text, displayed right next to the <input> tag.
  'name'    => 'stat_enabled',                          // The content of the 'id' attribute of the <input> tag.
  'values'  => array(
    'query' => $op_status,                           // $options contains the data itself.
    'id'    => 'id_option',                        // The value of the 'id' key must be the same as the key for 'value' attribute of the <option> tag in each $options sub-array.
    'name'  => 'name'                              // The value of the 'name' key must be the same as the key for the text content of the <option> tag in each $options sub-array.
  ),
),

				
			
			),
			
			
			
			
			
			'submit' => array(
				'name' => 'submitscapi',
				'title' => $this->l('Save'),
				'class' => 'button'
			)
		);
		
				
		
		
		//$this->fields_value['sckassa_apiid'] = Configuration::get('sckassa_apiid');
		$this->fields_value['api_url'] = Configuration::get('api_url');
		$this->fields_value['api_token'] = Configuration::get('api_token');
		$this->fields_value['api_app'] = Configuration::get('api_app');
		$this->fields_value['send_check'] = Configuration::get('send_check');
		$this->fields_value['nds_id'] = Configuration::get('nds_id');
		$this->fields_value['api_comment'] = Configuration::get('api_comment');		
		$this->fields_value['logi_enabled_1'] = Configuration::get('logi_enabled_1');

		/*-----------Статусы-------*/
		$sql = 'SELECT * FROM `'._DB_PREFIX_.'order_state_lang`';
			if ($results = Db::getInstance()->ExecuteS($sql))
			foreach ($results as $row)
			{
			$st_var = 'stat_enabled_'.$row['id_order_state'];
			$this->fields_value[$st_var] = Configuration::get($st_var);					
			}
		
		
		
		$helper = $this->initForm();
		$helper->submit_action = '';
		
		$helper->title = $this->displayName;
		
		$helper->fields_value = $this->fields_value;
		$this->_html .= $helper->generateForm($this->fields_form);
		
		$log_en = Configuration::get('logi_enabled_1');
		$log_file_name = Configuration::get('log_file_name');
		
		
		if ($log_en =='on') {
			
		$file_name =dirname(__DIR__).'/shopcontrol/'.$log_file_name.'.txt';
		
		if (is_readable($file_name)){ //доступен ли файл для чтения
		
		$file = fopen($file_name, 'r');  $str = ""; // считываем все из файла 
		
		$n=0;
		while (!feof($file)) {  
		$buffer = fgets($file, 1024);
		$str .= '<p>'.$buffer.'</p>';
		if ($n==200) break;
		$n++;
		} 
		fclose($file); 
		$this->_html .='<fieldset><a href="http://help-kassa.shop-ctrl.ru/index.php?post_id=270" target="_blank">Обработка результа</a>';
		$this->_html .=''.$str.'</fieldset>';
		
		}
		
		}
		
		return;
	}

	private function initForm()
	{
		$helper = new HelperForm();
		
		$helper->module = $this;
		$helper->name_controller = 'shopcontrol';
		$helper->identifier = $this->identifier;
		$helper->token = Tools::getAdminTokenLite('AdminModules');
		$helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
		$helper->toolbar_scroll = true;
		$helper->tpl_vars['version'] = $this->version;
		$helper->tpl_vars['author'] = $this->author;
		$helper->tpl_vars['this_path'] = $this->_path;
		$helper->toolbar_btn = $this->initToolbar();
		
		return $helper;
	}

	private function _postValidation()
	{
		/*
		if(Tools::getValue('sckassa_apiid')&&(!Validate::isInt(Tools::getValue('sckassa_apiid'))))
			$this->_postErrors[] = $this->l('Invalid').' '.$this->l('API ID');
		*/
		
		if(Tools::getValue('api_url')&&(!Validate::isUrl(Tools::getValue('api_url'))))
			$this->_postErrors[] = $this->l('Invalid').' '.$this->l('url');
		/*
		if((Tools::getValue('api_token')))
			$this->_postErrors[] = $this->l('Invalid').' '.$this->l('token');*/
		
		if(Tools::getValue('api_app')&&(!Validate::isInt(Tools::getValue('api_app'))))
			$this->_postErrors[] = $this->l('Invalid').' '.$this->l('app');
		
		if(Tools::getValue('send_check')&&(!Validate::isBool(Tools::getValue('send_check'))))
			$this->_postErrors[] = $this->l('Invalid').' '.$this->l('Отправка данных');
		/*
		if(Tools::getValue('nds_id')&&(!Validate::isBool(Tools::getValue('nds_id'))))
			$this->_postErrors[] = $this->l('Invalid').' '.$this->l('nds');
		*/
	}

	private function _postProcess()
	{

		//Configuration::updateValue('sckassa_apiid', Tools::getValue('sckassa_apiid'));		
		Configuration::updateValue('api_url', Tools::getValue('api_url'));		
		Configuration::updateValue('api_token', Tools::getValue('api_token'));
		Configuration::updateValue('api_app', Tools::getValue('api_app'));
		Configuration::updateValue('send_check', Tools::getValue('send_check'));
		Configuration::updateValue('nds_id', Tools::getValue('nds_id'));
		Configuration::updateValue('api_comment', Tools::getValue('api_comment'));
		
		Configuration::updateValue('logi_enabled_1', Tools::getValue('logi_enabled_1'));
		
	/*---------Обновление статус срабатывания--------*/
	$sql = 'SELECT * FROM `'._DB_PREFIX_.'order_state_lang`';
	if ($results = Db::getInstance()->ExecuteS($sql))
	foreach ($results as $row)
	{
	$st_var = 'stat_enabled_'.$row['id_order_state'];
	Configuration::updateValue($st_var, Tools::getValue($st_var));		
	}
		
		
		
		
		$log_en = Configuration::get('logi_enabled_1');
		/*-------Если отключили убираем лог------*/ 
		if ($log_en !='on') {
		$log_file_name = Configuration::get('log_file_name');
		$file_name =dirname(__DIR__).'/shopcontrol/'.$log_file_name.'.txt';	
		if (is_readable($file_name)){  
		$result = unlink($file_name);  
		}			
		}
		
		
		$this->_html .= $this->displayConfirmation($this->l('Настройки обновлены.'));
		
	}

public function hookActionObjectOrderAddAfter($params)
{
	

		
}	
	
	

public function hookActionOrderStatusUpdate($params)
    {

$send_check=0;
$send_check = Configuration::get('send_check');

if ($send_check==0) return;


$api_token='';$api_url='';$api_app='';$nds_id='';	

$api_token = Configuration::get('api_token');
$api_app = Configuration::get('api_app');		
$api_url = Configuration::get('api_url');
$api_comment = Configuration::get('api_comment');
$log_file_name = Configuration::get('log_file_name');	

$nds_id = Configuration::get('nds_id');	

switch ($nds_id) {
    case 1:
        $nds='';
        break;
    case 2:
        $nds='0';
        break;
    case 10:
        $nds='10';
        break;
	 case 18:
        $nds='18';
        break;
	 case 110:
        $nds='110';
        break;	
	case 118:
        $nds='118';
        break;
	default:
		$nds='';
}	


$par = json_encode($params, JSON_UNESCAPED_UNICODE);
$params_json =json_decode($par); // Превращаем строку в объект	
	

$new_id_order_state=0;
$new_id_order_state = $params_json->newOrderStatus->id;
$new_id_order_state =(int)$new_id_order_state; //909






if ($new_id_order_state==0) return;

//if ($paid==0) return;
$status_flag=0;

			$sql = 'SELECT * FROM `'._DB_PREFIX_.'order_state_lang`';
			if ($results = Db::getInstance()->ExecuteS($sql))
			foreach ($results as $row)
			{
			$st_var = 'stat_enabled_'.$row['id_order_state'];
			$id_order_state = $row['id_order_state'];
			$id_order_state =(int)$id_order_state;
			
			$stus = Configuration::get($st_var); // 
				
			
			if ($stus =='on') {
				
			if ($new_id_order_state==$id_order_state) {
			$status_flag=1;	
			}	
				
			}
				
			}
 
if ($status_flag==0) return; //Сработает только от нужных статусов
 
$id_order = $params_json->id_order;	



$status = Configuration::get('PS_OS_PAYMENT'); //статуса 2 ( Принимается оплата)
//«Платеж удаленно принят» - PS_OS_WS_PAYMENT 

	
$order = new Order($id_order);

$amount = number_format($order->total_paid, 2, '.', '');

$id_customer = $order->id_customer;

$customer = new Customer($id_customer);

$email =$customer->email;

$ProductDetailObject = new OrderDetail;

			$products = $ProductDetailObject->getList($id_order);
			
			$contents = array();
			$code ='';
			$zakaz = '';
			$t_numb=1;

			
foreach ($products as $product)
			{
								
				$price = $product['unit_price_tax_incl'];
				$price = (float)$price * 1;
				$quantity = $product['product_quantity'];
				$quantity = (float)$quantity * 1;
				$summa = $price * $quantity;
				$code = $product['product_reference'];
				$t_name = trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($product['product_name'])));
			   $contents[] = array(
					'productName' => $t_name,
					'code' => $code,
					'price' => $price,
					'quantity' => $quantity,
					'amount' => $summa,
					'nds' => $nds,
				);
				
					
					$zakaz .= $t_numb.'.';	
					$zakaz .= $t_name.' ';	
					$zakaz .= $quantity.' * ';	
					$zakaz .= $price;
					/*
					if 	(($ro["discont"])*1 <>0) {
					$zakaz .= ' '.$ro["discont"];
					}	
					*/
					$zakaz .= ' = '.$summa.' р.';;	
					$zakaz .='; ';

					$t_numb++;
				
				
			}			


			
$priority=1000;
$site = $_SERVER['SERVER_NAME'];			
			
$order = array (
  "token" => $api_token, 	// Token - секретный ключ доспупа к API (см. тут https://my.shop-ctrl.ru/reports/set )
  "app" => $api_app, 			//код виртуальной кассы к которой привязан фискальный аппарат (см тут https://my.shop-ctrl.ru/crm/cashboxs ) 
  "comment" => $api_comment, 			   		// комментарий операции.
  "operation" => "print",							//команда (обязательный параметр)  
  "site" => $site, 		  		// Адрес интернет магазина.
  "priority" => $priority,								//приоритет на выполнение (целое число 0 -1000000), чем больше число, тем выше приоритет 
  "email" 	  => $email,	// электронная почта покупателя
  "contents" => $contents,
  "nc_sum" => $amount,
  "exterNum" => $id_order //номер заказа, для контроля
);	

	$json = json_encode($order, JSON_UNESCAPED_UNICODE);

$url =$api_url; 

$curl = curl_init();//иницилизация сеанса
curl_setopt($curl,CURLOPT_URL, $url); //В этой опции задаётся адрес
curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "POST"); //метод POST
curl_setopt($curl,CURLOPT_SSL_VERIFYPEER, false);//чтобы наш сервер не проверял ваш сертификат (мы с собой никаких сертификатов не принесли, пустите нас так пожалуйста.)
curl_setopt($curl,CURLOPT_SSL_VERIFYHOST, false);
curl_setopt($curl, CURLOPT_HTTPHEADER, array('Content-Type: application/json',
											 'Content-Length: ' . strlen($json)));
curl_setopt($curl, CURLOPT_POSTFIELDS, $json);
curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);//вывода ответа от сервера: в браузер (значение false) или же возвращать ответ (значение true)

$response = curl_exec($curl);//Получаем данные
curl_close($curl); 

/*---------обработка ошибок----------*/

$resp =json_decode($response); // Превращаем строку в объект

// Отлавливаем ошибки возникшие при превращении
switch (json_last_error()) {
  case JSON_ERROR_NONE:
    $data_error = '';
    break;
  case JSON_ERROR_DEPTH:
    $data_error = 'Достигнута максимальная глубина стека';
    break;
  case JSON_ERROR_STATE_MISMATCH:
    $data_error = 'Неверный или не корректный JSON';
    break;
  case JSON_ERROR_CTRL_CHAR:
    $data_error = 'Ошибка управляющего символа, возможно верная кодировка';
    break;
  case JSON_ERROR_SYNTAX:
    $data_error = 'Синтаксическая ошибка';
    break;
  case JSON_ERROR_UTF8:
    $data_error = 'Некорректные символы UTF-8, возможно неверная кодировка';
    break;  
  default:
    $data_error = 'Неизвестная ошибка';
    break;
}

// Если ошибки есть, то выводим их или как то обрабатываем
if($data_error !='') {
$err = 'err: '.$data_error.'&#8195;';
}
else {
$err ='';	
}

// Присваиваим данные переменным

$result = $resp->result; 
$code = $resp->code;
$info = $resp->info;
$exterNum = $resp->data->exterNum;
$id_res = $resp->data->id;

if ($result=='ok') {
$status=1;
$status_info='';
} else {
	$status=0;
	$status_info =$code.' '.$info;
	}

	
	
	
	
	
	
	
	//Call to undefined method DbPDO::autoExecute()
	
	

$PositionSC = new SC;
$sctrl_fisc = _DB_PREFIX_."sctrl_fisc";

Db::getInstance()->insert ($sctrl_fisc, array(

	'position' => $PositionSC -> getLastPosition(),
	'date_add' => date("Y-m-d H:i:s"),
	'api_url' => $api_url,
	'zakaz' => $zakaz,
	'zakaz_json' => $json,
	'summa' => $amount,
	'exterNum' => $id_order,
	'email' =>    $email,
	'status' =>    $status,
	'info' =>    $status_info,
	'active' =>    1
		
));



$log_en = Configuration::get('logi_enabled_1');	
	
if ($log_en =='on') { //Если надо пишем лог
	
$log = date("Y-m-d H:i:s").'&#8195;'.$err.'&#8195;result: '.$result.'&#8195;';
$log .="code: ".$code.'&#8195;';
$log .="info: ".$info.'&#8195;';
$log .="id: ".($id_res*1).'&#8195;';
$log .="exterNum: ".$id_order.' ';
$log .="\r\n";

$log_file_name = Configuration::get('log_file_name');

$fa =dirname(__DIR__).'/shopcontrol/'.$log_file_name.'.txt';

$text_1=''; $n=0;

 if ($log!="") 
{
/*--------ограничим лог 500 строками-----*/
$handle = @fopen($fa, "r");
if ($handle) {
	while (($buffer = fgets($handle, 4096)) !== false) {
	$text_1 .=$buffer; 	
	if ($n==500) break;
	$n++;
	}	
fclose($handle);
}

//$text_1=file_get_contents($fa); 

$fd=$log.$text_1; 
$f_out = fopen($fa,"w"); 
fwrite($f_out, $fd);  
fclose($f_out); 
} 

}


    }


	public function hookActionPaymentConfirmation()
    {
	

    }
	
	
	
	public function hookheader($params)
	{
		
	}





}